//===========================================================================
// package
//===========================================================================
package jp.gr.java_conf.bugslife.selections;

//===========================================================================
// import
//===========================================================================
// Java core API
import java.util.*;
import java.text.*;

// DB API
import jp.gr.java_conf.bugslife.db.*;

// Util API
import jp.gr.java_conf.bugslife.util.*;
//import jp.gr.java_conf.bugslife.system.*;


/**
 *<PRE>
 * 
 * Screenクラス
 * 
 *</PRE>
 * @version	0.0, 2001/09/10
 * @author	鰐川　正寛
 */
//===========================================================================
public class Screen implements IUpdatable, ILoadable
{
//===========================================================================
// attributes
//===========================================================================
	/**
	 *	画面ＩＤ
	 */
	private String m_scid = null;
	/**
	 *	画面名称
	 */
	private String m_name = null;
	/**
	 *	リソース
	 */
	private String m_resource = null;
	/**
	 *	説明
	 */
	private String m_info = null;
	//add 08.02.11
	/**
	 *	表示フラグ
	 */
	private byte m_dispFlag = 1;
	/**
	 *	更新者
	 */
	private int m_updateUno = 0;
	/**
	 *	更新日時
	 */
	private Date m_updateDate = new Date();
//=====================================
// DB用項目定義
//=====================================
	/**
	 * 排他制御
	 */
	private static final boolean EXCLUSION = true;	//あり
	/**
	 * AutoIncrement
	 */
	private static final boolean ATOINCREMENT = false;	//なし
	/**
	 * PK 
	 */
	private static final String[] PK = {"scid"};
	/**
	 * 更新項目名
	 */
	private static final String[] DB_ITEMS = {
									"scid","name","resource",
									"dispFlag",					//08.02.11
									"info","updateUno" };
//===========================================================================
// methods
//===========================================================================
	/**
	 *	デフォルトコンストラクタ
	 *
	 */
	public Screen()
	{
		
	}
	/**
	 *	コンストラクタ(ＩＤ指定）
	 *
	 * @param	 scid		String型
	 */
	public Screen(String scid)
	{
		setScid(scid);
		
		load();
		
	}
//======================================
// db access methods
//======================================
	/**
	 *	insertDB
	 *
	 * @return	処理結果
	 */
	public void insert(int updateUno)
	{
		setUpdateUno(updateUno);
		DAO.insert(this);
		load();		//最終更新日がほしいので再ロード
	}
	/**
	 *	update
	 *
	 * @return	処理結果
	 */
	public void update(int updateUno)
	{
		setUpdateUno(updateUno);
		DAO.update(this);
		load();		//最終更新日がほしいので再ロード
	}
	/**
	 *	delete
	 *
	 * @return	処理結果
	 */
	public void delete(int updateUno)
	{
		setUpdateUno(updateUno);
		DAO.delete(this);
	}
	/**
	 *	load
	 *
	 * @return	処理結果
	 */
	public void load()
	{
		DAO.load(this);
	}
	/**
	 *	findAll
	 *
	 * @return	処理結果
	 */
	public static Collection findAll()
	{
		return DAO.findAll(new Screen());
	}
	/**
	 *	Screenの取得（コード指定）
	 *
	 * @return	処理結果
	 */
	public static Screen getScreen(String scid)
	{
		String sql = "SELECT * FROM Screen WHERE scid = ?";
		ArrayList params = new ArrayList();
		params.add(scid);
		
		ArrayList list = DAO.find(new Screen(), sql, params);
		
		Screen Screen = null;
		if ((list != null) && (list.size() > 0)) {
			Screen = (Screen)list.get(0);
		}
		return Screen;
	}
	//add  08.02.11
	/**
	 * ラベル表示用コレクション
	 */
	public static Collection getLabelCollection()
	{
		String sql = "SELECT scid,name FROM Screen where dispFlag = 1 ORDER BY scid";
		ArrayList params = new ArrayList();
		
		ArrayList list = DAO.find(new Screen(), sql, params);
		
		return list;
	}
	/**
	 * ラベル表示用コレクション(非表示含む）
	 */
	public static Collection getLabelCollectionForAdmin()
	{
		String sql = "SELECT scid,name FROM Screen ORDER BY scid";
		ArrayList params = new ArrayList();
		
		ArrayList list = DAO.find(new Screen(), sql, params);
		
		return list;
	}
//======================================
// Db Interface
//======================================
	/**
	 * 
	 */
	public String[] getUpdateItemNames() {
		
		return DB_ITEMS;
		
	}
	/**
	 * PK items
	 */
	 public String[] getPKItems() {
		return PK;
	}
	/**
	 * 排他制御ありなし
	 */
	public boolean isExclusion() {
		return EXCLUSION;
	}
	/**
	 * AutoIncrementありなし
	 */
	public boolean isAutoIncrement() {
		return ATOINCREMENT;
	}
//======================================
// request param
//======================================
	/**
	 *	request parametorの生成
	 */
	public Map getMapping() {
		HashMap map = new HashMap();
		map.put("t", "Screen");
		map.put("scid", m_scid);
		return map;
	}
//======================================
// Property
//======================================
	/**
	 * 画面IDの取得
	 * 
	 * @return 画面ID
	 */
	public String getScid()
	{
		return m_scid;
	}
	/**
	 * 画面IDのセット
	 * 
	 * @param scid 画面ID
	 */
	public void setScid(String scid)
	{
		m_scid = scid;
	}
	/**
	 * 名前の取得
	 * 
	 * @return 名前
	 */
	public String getName()
	{
		return m_name;
	}
	/**
	 * 名前の取得(ラベル用)
	 * 
	 * @return 名前
	 */
	public String getNameLabel()
	{
		String s = null;
		if ((m_scid == null) || (m_scid.equals(""))) {
			s = "";
		} else {
			s = m_scid + "-" + m_name;
		}
		return s;
	}
	/**
	 * 名前のセット
	 * 
	 * @param name 名前
	 */
	public void setName(String name)
	{
		m_name = name;
	}
	/**
	 * リソースの取得
	 * 
	 * @return リソース
	 */
	public String getResource()
	{
		return m_resource;
	}
	/**
	 * リソースのセット
	 * 
	 * @param resource リソース
	 */
	public void setResource(String resource)
	{
		m_resource = resource;
	}
	/**
	 * 説明の取得
	 * 
	 * @return 説明
	 */
	public String getInfo()
	{
		return m_info;
	}
	/**
	 * 説明のセット
	 * 
	 * @param info 説明
	 */
	public void setInfo(String info)
	{
		m_info = info;
	}
	/**
	 * 更新者の取得
	 * 
	 * @return 更新者
	 */
	public int getUpdateUno()
	{
		return m_updateUno;
	}
	/**
	 * 更新者のセット
	 * 
	 * @param updateUno 更新者
	 */
	public void setUpdateUno(int updateUno)
	{
		m_updateUno = updateUno;
	}
	/**
	 *	更新日の取得
	 *
	 * @return	update		更新日文字列
	 */
	public Date getUpdateDate()
	{
		return m_updateDate;
	}
	/**
	 *	更新日の取得
	 *
	 * @return	update		更新日文字列
	 */
	public String getUpdateDateString()
	{
		String s = null;
		if (m_updateDate != null) {
			s = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(m_updateDate);
		}
		return s;
	}
	/**
	 *	更新日のセット
	 *
	 * @return	update		更新日文字列
	 */
	public void setUpdateDate(Date date)
	{
		m_updateDate = date;
	}
    /**
     * @return 表示フラグ を戻します。
     */
    public byte getDispFlag() {
        return m_dispFlag;
    }
    /**
     * @param pFlag 表示フラグ を設定。
     */
    public void setDispFlag(byte pFlag) {
        m_dispFlag = pFlag;
    }
//===========================================================================
// methods
//===========================================================================
	/**
	 *	クラス情報
	 */
	public String toString()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("--- [Screen] --- \n");
		sb.append("scid     : " + m_scid + "\n");
		sb.append("name     : " + m_name + "\n");
		sb.append("resource : " + m_resource + "\n");
		sb.append("info     : " + m_info + "\n");
		//08.02.11
		sb.append("dispflag : " + m_dispFlag + "\n");
		
		sb.append("updateUno: " + m_updateUno + "\n");
		sb.append("updateDat: " + getUpdateDateString() + "\n");
		sb.append("--- [Screen] --- \n");
		return sb.toString();
	}
	/**
	 * debug
	 */
	private static void debug(String s) {
		 
		 System.out.println("[Screen]" + s);
		 
	}
	/**
	 *	テストメイン
	 */
	public static void main(String[] args)
	{
		System.out.println("------- << Screen Test Start >> -----------");
		unitTest1();	//新規作成テスト
		unitTest2();	//更新テスト
		unitTest3();	//削除テスト
		unitTest4();	//全件取得テスト
		unitTest5();	//コード指定コンストラクトテスト
		unitTest6();	//ラベル用コレクションテスト
		
		System.out.println("------- << Screen Test End >> -----------");
	}
	
	/**
	 *	unitTest1
	 *
	 * 新規作成テスト
	 *
	 */
	public static void unitTest1()
	{
		System.out.println("------- unitTest1 -----------");
		
		//存在チェック
		Screen target = Screen.getScreen("NOF_AXXDXX");
		if (target != null) {
			//存在していたら削除する
			target.delete(1);
		}
		//値のセット
		Screen screen = new Screen();
		screen.setScid("NOF_AXXDXX");
		screen.setName("名前");
		screen.setResource("略称");
		screen.setInfo("説明");
		
		//追加
		screen.insert(0);
		
		System.out.println(screen.toString());
	}
	/**
	 *	unitTest2
	 *
	 * 更新テスト
	 *
	 */
	public static void unitTest2()
	{
		System.out.println("------- unitTest2 -----------");
		
		//存在チェック
		Screen screen = Screen.getScreen("NOF_AXXDXX");
		if (screen == null) {
			//存在していなかったらテスト中止
			throw new Error("target is nothing");
		}
		
		System.out.println(screen.toString());
		
		screen.setName("名前２");
		screen.setResource("略称２");
		screen.setInfo("説明２");
		//更新
		screen.update(1);
		
		System.out.println(screen.toString());
	}
	/**
	 *	unitTest3
	 *
	 * 削除テスト
	 *
	 */
	public static void unitTest3()
	{
		System.out.println("------- unitTest3 -----------");
		
		//存在チェック
		Screen screen = Screen.getScreen("NOF_AXXDXX");
		if (screen == null) {
			//存在していなかったらテスト中止
			throw new Error("target is nothing");
		}
		
		System.out.println(screen.toString());
		
		//削除
		screen.delete(2);
		
		//存在チェック
		screen = Screen.getScreen("NOF_AXXDXX");
		if (screen != null) {
			//存在していなかったらテスト中止
			throw new Error("delete failer");
		}
	}
	/**
	 *	unitTest4
	 *
	 * 全件取得テスト
	 *
	 */
	public static void unitTest4()
	{
		System.out.println("------- unitTest4 -----------");
		
		Collection list = Screen.findAll();
		display(list);
	}
	/**
	 *	unitTest5
	 *
	 * コードコンストラクトテスト
	 *
	 */
	public static void unitTest5()
	{
		System.out.println("------- unitTest5 -----------");
		
		Screen Screen = new Screen("NOF_A01D01");
		
		System.out.println(Screen.toString());
	}
	/**
	 *	unitTest6
	 *
	 * ラベル用コレクションの取得
	 *
	 */
	public static void unitTest6()
	{
		System.out.println("------- unitTest6 -----------");
		
		display(Screen.getLabelCollection());
		
	}
	/**
	 * リストの表示
	 *
	 */
	private static void display(Collection list)
	{
		Iterator ite = list.iterator();
		
		while(ite.hasNext()) {
			Screen Screen = (Screen)ite.next();
			
			System.out.println(Screen.getNameLabel());
		}
	}
}